/*
======================================================================
SR_rigging is a simple auto rigging script that creates a rigg based
on the skelgons in your model.

www.Steelronin.com
Scott@steelronin.com  
======================================================================
*/

scriptName = "Rigging v0.3.1";
copyright = "Copyright (c) 2004 Scott lange";

/*
updates comments
v0.3.1 remove hand rigging
*/ 

@version 2.2
@warnings
@name SR_Rigging
@script generic


generic
{
//debug();
    // base input values

    // perform all processing here
    scene = Scene();
    pip = scene.generalopts[3];
    sList = Scene().getSelect();
    if(sList == nil) return;

    // reverse slist order
    listcopy = sList;
    for(a=1;a<=size(listcopy);a++)
        sList[(size(listcopy)+1) - a]=listcopy[a];

    // interface

    //define callback var

    // set Parent in place

    if(pip){
    }
    else{
        ParentInPlace();
    }

    // set enable ik
    //if(EnableIK == 1);{info(IK on");}
    //else{info(IK off);}

    // setup some variables

    t = Scene().currenttime;
    n = size(sList);
    i;
    s;

    GoToFrame(0);
    RefreshNow();


// creat the skelegons in the first model    
    SelectItem(sList[1].id);
    AutoConfirm(1);
    SkelegonsToBones();
    EnableIK();
    ParentInPlace();
    RefreshNow();

// repostion bones to skelegons
    SelectByName("Root");
    ParentItem("Root_Sgon");
    SelectByName("Hips");
    ParentItem("Hips_Sgon");
    SelectByName("L_Hip");
    ParentItem("L_Hip_Sgon");
    SelectByName("L_Uleg");
    ParentItem("L_Uleg_Sgon");
    SelectByName("L_knee");
    ParentItem("L_knee_Sgon");
    SelectByName("L_Foot");
    ParentItem("L_Foot_Sgon");
    SelectByName("L_Toe");
    ParentItem("L_Toe_Sgon");
    SelectByName("R_Hip");
    ParentItem("R_Hip_Sgon");
    SelectByName("R_Uleg");
    ParentItem("R_Uleg_Sgon");
    SelectByName("R_knee");
    ParentItem("R_knee_Sgon");
    SelectByName("R_Foot");
    ParentItem("R_Foot_Sgon");
    SelectByName("R_Toe");
    ParentItem("R_Toe_Sgon");
    SelectByName("Spin");
    ParentItem("Spin_Sgon");
    SelectByName("Chest");
    ParentItem("Chest_Sgon");
    SelectByName("Neck");
    ParentItem("Neck_Sgon");
    SelectByName("Head");
    ParentItem("Head_Sgon");
    SelectByName("L_Clav");
    ParentItem("L_Clav_Sgon");
    SelectByName("L_Shoul");
    ParentItem("L_Shoul_Sgon");
    SelectByName("L_Uarm");
    ParentItem("L_Uarm_Sgon");
    SelectByName("L_Elbo");
    ParentItem("L_Elbo_Sgon");
    SelectByName("L_Hand");
    ParentItem("L_Hand_Sgon");
    // left fingers old place
    SelectByName("R_Clav");
    ParentItem("R_Clav_Sgon");
    SelectByName("R_Shoul");
    ParentItem("R_Shoul_Sgon");
    SelectByName("R_Uarm");
    ParentItem("R_Uarm_Sgon");
    SelectByName("R_Elbo");
    ParentItem("R_Elbo_Sgon");
    SelectByName("R_Hand");
    ParentItem("R_Hand_Sgon");
    // right fingers old place
    SelectByName("L_Pad");
    ParentItem("L_Pad_Sgon");
    SelectByName("R_Pad");
    ParentItem("R_Pad_Sgon");

    // fingers removed


    RefreshNow();
    GoToFrame(1);
    GoToFrame(0);
    RefreshNow();
    ParentInPlace();
    RefreshNow();

    SelectByName("Root");
    ParentItem(sList[1].id);
    SelectByName("Hips");
    ParentItem("Root");
    SelectByName("L_Hip");
    ParentItem("Hips");
    SelectByName("L_Uleg");
    ParentItem("L_Hip");
    SelectByName("L_knee");
    ParentItem("L_Uleg");
    SelectByName("L_Foot");
    ParentItem("L_knee");
    SelectByName("L_Toe");
    ParentItem("L_Foot");
    SelectByName("R_Hip");
    ParentItem("Hips");
    SelectByName("R_Uleg");
    ParentItem("R_Hip");
    SelectByName("R_knee");
    ParentItem("R_Uleg");
    SelectByName("R_Foot");
    ParentItem("R_knee");
    SelectByName("R_Toe");
    ParentItem("R_Foot");
    SelectByName("Spin");
    ParentItem("Root");
    SelectByName("Chest");
    ParentItem("Spin");
    SelectByName("Neck");
    ParentItem("Chest");
    SelectByName("Head");
    ParentItem("Neck");
    SelectByName("L_Clav");
    ParentItem("Neck");
    SelectByName("L_Shoul");
    ParentItem("L_Clav");
    SelectByName("L_Uarm");
    ParentItem("L_Shoul");
    SelectByName("L_Elbo");
    ParentItem("L_Uarm");
    SelectByName("L_Hand");
    ParentItem("L_Elbo");
// left fingers old place

    SelectByName("R_Clav");
    ParentItem("Neck");
    SelectByName("R_Shoul");
    ParentItem("R_Clav");
    SelectByName("R_Uarm");
    ParentItem("R_Shoul");
    SelectByName("R_Elbo");
    ParentItem("R_Uarm");
    SelectByName("R_Hand");
    ParentItem("R_Elbo");
// right fingers old place

    SelectByName("L_Pad");
    ParentItem("Neck");
    SelectByName("R_Pad");
    ParentItem("Neck");
    RefreshNow();

    SelectItem("Root_Sgon");
    AddToSelection("Hips_Sgon");
    AddToSelection("L_Hip_Sgon");
    AddToSelection("L_Uleg_Sgon");
    AddToSelection("L_knee_Sgon");
    AddToSelection("L_Foot_Sgon");
    AddToSelection("L_Toe_Sgon");
    AddToSelection("R_Hip_Sgon");
    AddToSelection("R_Uleg_Sgon");
    AddToSelection("R_knee_Sgon");
    AddToSelection("R_Foot_Sgon");
    AddToSelection("R_Toe_Sgon");
    AddToSelection("Spin_Sgon");
    AddToSelection("Chest_Sgon");
    AddToSelection("Neck_Sgon");
    AddToSelection("Head_Sgon");
    AddToSelection("L_Clav_Sgon");
    AddToSelection("L_Shoul_Sgon");
    AddToSelection("L_Uarm_Sgon");
    AddToSelection("L_Elbo_Sgon");
    AddToSelection("L_Hand_Sgon");

    AddToSelection("R_Clav_Sgon");
    AddToSelection("R_Shoul_Sgon");
    AddToSelection("R_Uarm_Sgon");
    AddToSelection("R_Elbo_Sgon");
    AddToSelection("R_Hand_Sgon");

    AddToSelection("L_Pad_Sgon");
    AddToSelection("R_Pad_Sgon");
    ClearSelected();
    RefreshNow();

// procces bones
    SelectItem("Root");
    AddToSelection("Hips");
    AddToSelection("L_Hip");
    AddToSelection("L_Uleg");
    AddToSelection("L_knee");
    AddToSelection("L_Foot");
    AddToSelection("L_Toe");
    AddToSelection("R_Hip");
    AddToSelection("R_Uleg");
    AddToSelection("R_knee");
    AddToSelection("R_Foot");
    AddToSelection("R_Toe");
    AddToSelection("Spin");
    AddToSelection("Chest");
    AddToSelection("Neck");
    AddToSelection("Head");
    AddToSelection("L_Clav");
    AddToSelection("L_Shoul");
    AddToSelection("L_Uarm");
    AddToSelection("L_Elbo");
    AddToSelection("L_Hand");

    AddToSelection("R_Clav");
    AddToSelection("R_Shoul");
    AddToSelection("R_Uarm");
    AddToSelection("R_Elbo");
    AddToSelection("R_Hand");

    AddToSelection("L_Pad");
    AddToSelection("R_Pad");

    BoneActive();
    RecordRestPosition();

    SelectByName("Root");
    BoneActive();
    SelectByName("L_Hip");
    BoneActive();
    SelectByName("R_Hip");
    BoneActive();
    SelectByName("L_Clav");
    BoneActive();
    SelectByName("L_Shoul");
    BoneActive();
    SelectByName("R_Clav");
    BoneActive();
    SelectByName("R_Shoul");
    BoneActive();
    RefreshNow();


// creat the rigg

    SelectItem("L_Foot_Rig");
    AddToSelection("R_Foot_Rig");
    AddToSelection("Lookat_Rig");
    AddToSelection("L_Shoulder_Rig");
    AddToSelection("L_Elbo_Rig");
    AddToSelection("L_Wrist_Rig");
    AddToSelection("R_Shoulder_Rig");
    AddToSelection("R_Elbo_Rig");
    AddToSelection("R_Wrist_Rig");


    CreateKey(0);
    ParentInPlace();
    RefreshNow();
    SelectItem("L_Hand_Rig");
    ParentItem("L_Hand");
    SelectItem("R_Hand_Rig");
    ParentItem("R_Hand");
    SelectItem("L_Pad_Rig");
    ParentItem("L_Pad");
    SelectItem("R_Pad_Rig");
    ParentItem("R_Pad");
    RefreshNow();
    ParentInPlace();
    RefreshNow();
    SelectItem("L_Pad_Rig");
    ParentItem("Neck");
    SelectItem("R_Pad_Rig");
    ParentItem("Neck");
    RefreshNow();
    
    
    SelectItem(sList[2].id);
    SkelegonsToBones();
    ParentInPlace();
    RefreshNow();
    SelectByName("Upper_body_Rig");
    ParentItem("Upper_body_SRig");
    SelectByName("Hips_Rig");
    ParentItem("Hips_SRig");
    SelectByName("L_Ankle_Rig");
    ParentItem("L_Ankle_SRig");
    SelectByName("L_Ball_Rig");
    ParentItem("L_Ball_SRig");
    SelectByName("L_Toe_Rig");
    ParentItem("L_Toe_SRig");
    SelectByName("L_Foot_Rig");
    ParentItem("L_Foot_SRig");
    SelectByName("R_Ankle_Rig");
    ParentItem("R_Ankle_SRig");
    SelectByName("R_Ball_Rig");
    ParentItem("R_Ball_SRig");
    SelectByName("R_Toe_Rig");
    ParentItem("R_Toe_SRig");
    SelectByName("R_Foot_Rig");
    ParentItem("R_Foot_SRig");
    SelectByName("Lookat_Rig");
    ParentItem("Lookat_SRig");
    ParentInPlace();
    RefreshNow();
    SelectByName("Upper_body_Rig");
    ParentItem(sList[2].id);
    SelectByName("Hips_Rig");
    ParentItem("Upper_body_Rig");
    SelectByName("L_Ankle_Rig");
    ParentItem("L_Ball_Rig");
    SelectByName("L_Ball_Rig");
    ParentItem("L_Toe_Rig");
    SelectByName("L_Toe_Rig");
    ParentItem("L_Foot_Rig");
    SelectByName("L_Foot_Rig");
    ParentItem(sList[2].id);
    SelectByName("R_Ankle_Rig");
    ParentItem("R_Ball_Rig");
    SelectByName("R_Ball_Rig");
    ParentItem("R_Toe_Rig");
    SelectByName("R_Toe_Rig");
    ParentItem("R_Foot_Rig");
    SelectByName("R_Foot_Rig");
    ParentItem(sList[2].id);
    SelectByName("Lookat_Rig");
    ParentItem("Upper_body_Rig");
    
    SelectByName("L_Elbo_Rig");
    ParentItem("Upper_body_Rig");
    
    SelectByName("L_Wrist_Rig");
    ParentItem("Upper_body_Rig");
    
    SelectByName("R_Elbo_Rig");
    ParentItem("Upper_body_Rig");
    
    SelectByName("R_Wrist_Rig");
    ParentItem("Upper_body_Rig");
    
    
    SelectItem("Upper_body_SRig");
    AddToSelection("Hips_SRig");
    AddToSelection("L_Knee_SRig");
    AddToSelection("L_Foot_SRig");
    AddToSelection("L_Toe_SRig");
    AddToSelection("L_Ball_SRig");
    AddToSelection("L_Ankle_SRig");
    AddToSelection("R_Knee_SRig");
    AddToSelection("R_Foot_SRig");
    AddToSelection("R_Toe_SRig");
    AddToSelection("R_Ball_SRig");
    AddToSelection("R_Ankle_SRig");
    AddToSelection("Spin_SRig");
    AddToSelection("Lookat_SRig");
    AddToSelection("L_Shoulder_SRig");
    AddToSelection("L_Elbo_SRig");
    AddToSelection("L_Wrist_SRig");
    AddToSelection("L_Hand_SRig");
    AddToSelection("R_Shoulder_SRig");
    AddToSelection("R_Elbo_SRig");
    AddToSelection("R_Wrist_SRig");
    AddToSelection("R_Hand_SRig");
    AddToSelection("L_Pad_SRig");
    AddToSelection("R_Pad_SRig");
    
    
    ClearSelected();
    RefreshNow();
    SelectByName("L_Knee_Rig");
    CreateKey(0);
    RefreshNow();
    SelectByName("R_Knee_Rig");
    CreateKey(0);
    SelectByName("Head");
    HController(2);
    PController(2);
    
    GoToFrame(-1);
    RefreshNow();
    SelectItem("L_knee");
    Rotation(0,30,0);
    
    SelectItem("R_knee");
    Rotation(0,30,0);
    
    SelectItem("L_Elbo");
    Rotation(30,0,0);
    
    SelectItem("R_Elbo");
    Rotation(-30,0,0);
    GoToFrame(0);
    RefreshNow();
    
    EnableIK();
    SelectItem("Root");
 
}


